clear all
close all
clc


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ARMA Representation and Stocks
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 1.

load TP9.mat
CocaPrices=data(6:end,5);
CreditSuissePrices=data(6:end,3);

autocorr(CocaPrices)
title('CocaPrices - Sample Autocorrelation Function (ACF)')
figure
parcorr(CocaPrices)
title('CocaPrices - Sample Partial Autocorrelation Function (PACF)')

figure
autocorr(CreditSuissePrices)
title('CreditSuissePrices - Sample Autocorrelation Function (ACF)')
figure
parcorr(CreditSuissePrices)
title('CreditSuissePrices - Sample Partial Autocorrelation Function (PACF)')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 2.

CocaLogReturns=log(CocaPrices(2:end))-log(CocaPrices(1:end-1));
CreditSuisseLogReturns=log(CreditSuissePrices(2:end))-log(CreditSuissePrices(1:end-1));

figure
autocorr(CocaLogReturns)
title('CocaLogReturns - Sample Autocorrelation Function (ACF)')
figure
parcorr(CocaLogReturns)
title('CocaLogReturns - Sample Partial Autocorrelation Function (PACF)')

figure
autocorr(CreditSuisseLogReturns)
title('CreditSuisseLogReturns - Sample Autocorrelation Function (ACF)')
figure
parcorr(CreditSuisseLogReturns)
title('CreditSuisseLogReturns - Sample Partial Autocorrelation Function (PACF)')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 3.

[H,pValue,Stat,CriticalValue]=lbqtest(CreditSuisseLogReturns,[5 10 15 20]',0.05);
[H  pValue  Stat  CriticalValue]

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 4.

y=CreditSuisseLogReturns(5:end);
X=[ones(length(CreditSuisseLogReturns)-4,1) CreditSuisseLogReturns(4:end-1) CreditSuisseLogReturns(3:end-2) CreditSuisseLogReturns(2:end-3) CreditSuisseLogReturns(1:end-4)];
  
[b,bint,resids]=regress(y,X);

b

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 5.

figure
autocorr(resids)
title('Credit Suisse Log-Returns - AR(4) Residuals - Sample ACF')
figure
parcorr(resids)
title('Credit Suisse Log-Returns - AR(4) Residuals - Sample PACF')

[H,pValue,Stat,CriticalValue]=lbqtest(resids,[5 10 15 20]',0.05);
[H  pValue  Stat  CriticalValue]